// times.c
// $Id: times.c,v 1.2 2007/11/13 11:45:17 sendan Exp $
// masashi shimakura

#include<stdio.h>
#include<unistd.h>
#include<netinet/in.h>
#include<string.h>
#include<stdlib.h>
#include<time.h>
#include<arpa/inet.h>
#include<pthread.h>

#include"sitar.h"
#include<almemsys/almemsys.h>

/*
int time_getr(char [], int);
long int u_time(void);
int mail_time_getr(char [], int, char *);
long int ctime_getr(char);
*/


char * char_wday(int);
char * char_mon(int);
int time_minus(int, int, char);
int m_sec(int);
int ch_time_munus(int, int, int);
int ch_time_plues(int, int, int);
int day_minus(int);
int year_minus(int);
int month_last(int, int);
int m_last(int, int);
int month_miuns(int);
time_t get_unixtime(int, int, int, int, int, int);

extern struct buff_set bf;





int hloop(int year_b, int month_b, int day_b, int hour_b, int min_b, int mmin)
{
int year, month, day, hour, min;
int ret;
time_t u_settime;
time_t u_present;
time_t m_present;

ret = -1; 

// year 2020 以上はなし、2008以下は2008に
if(year_b == 100){ year = ctime_getr('y'); }
else if(year_b >= 2020){ year = 2020; }
else if(year_b <= 2008){ year = 2008; }
else{ year = year_b; }

// month 13を12に 100の場合はmon_setを1に
if(month_b == 100){ month = ctime_getr('m'); }
else if(month_b >= 1){ month = 12; }
else if(month_b <= 0){ month = 1; }
else{ month = month_b; }

// hour 24を0に整理 100 の場合はh_set を1に
if(hour_b == 100){ hour = ctime_getr('h'); }
else if(hour_b >= 24){ hour = 0; }
else if(hour_b <= 0){ hour = 0; }
else{ hour = hour_b; }

// day 32を0に整理 100 の場合は d_set を1 に
if(day_b == 100){ day = ctime_getr('d'); }
else if(day_b >= 32){ day = 31; }
else if(day_b <= 0){ day = 1; }
else{ day = day_b; }

// min 60を0に整理
if(min_b >= 60){ min = 60; }
else if(min_b <= 0){ min = 0; }
else{ min = min_b; }


// 設定UNIX時間を得る
u_settime = get_unixtime(year, month, day, hour, min, 0);

// 現在のUNIX時間を得る
u_present = (time_t)u_time();


#ifdef MUTEX_BUG
printf("------------\n");
printf("MUTEX: hloop():設定年=%d, 設定月=%d, 設定日=%d, 設定時=%d, 設定分=%d, 設定UNIX=%ld, 現在UNIX=%ld, 差=%ld, 加算秒=%d\n",
        year, month, day, hour, min, u_settime, u_present, (u_settime - u_present), mmin);
printf("MUTEX: hloop():現在時=%d, 現在分=%d\n",
        ctime_getr('h'), ctime_getr('i'));
#endif


m_present = u_present - (u_settime - (mmin + 60));
if(m_present <= (mmin + 60) && m_present > 0){
   #ifdef MUTEX_BUG
   printf("MUTEX: hloop(): JUST の条件を満たしたので、LOOPに入ります UNIX<%ld> %d 秒かかるかもしれません 現在分=%d\n",
      u_present, (mmin + 60), ctime_getr('i'));
   #endif 
   while(1){ 
      sleep(10);
      // 現在のUNIX時間を得る
      u_present = (time_t)u_time();
      #ifdef MUTEX_BUG
      printf("MUTEX: hloop(): JUST監視　UNIX<%ld>\n", u_present);
      #endif 
      if((u_settime - 15) < u_present && u_present >= u_settime){
         #ifdef MUTEX_BUG
         printf("MUTEX: hloop(): JUST の条件を満たしたLOOPから正常に抜けます、監視は実行されます 現在分=%d\n", ctime_getr('i'));
         #endif 
         ret = 1;
         break;
         }
      }
   }

return ret;
}




// 実時間 - 0からMSC前と実行したい時間が同じ場合に0
int ch_time_plues(int ma, int min, int msc)
{
int ret, co;
ret = -1;

for(co = 0; co <= msc; co++){
   if(min == time_minus(ma, co, 'i')){
      ret = 0;
      break;
      }
   }
return ret;
}




// 実行したい時間 - 0からMSC前と実時間が同じ場合に0
int ch_time_munus(int ma, int min, int msc)
{
int ret, co;
ret = -1;

for(co = 0; co <= msc; co++){
   if(ma == time_minus(min, co, 'i')){
      ret = 0;
      break;
      }
   }
return ret;
}





// 秒を分に変える関数、60以下は1になる。あまりが30より大きいと1＋
int m_sec(int sec)
{
int min;

if(sec <= 60){
   min = 1;
   }
else{
   min = sec / 60;
   if(30 <= sec % 60){
      min = min + 1;
      }
   }

return min;
}






// localな時間からUNIX時間をかえす。フォーマットチェックなし。
time_t get_unixtime(int ye, int mo, int day, int hour, int min, int sec)
{
time_t ret;
struct tm t;

t.tm_year = (ye - 1900);    /* 2001年 */
t.tm_mon  = (mo - 1);       /* 5月    */
t.tm_mday = day;            /* 20日   */
t.tm_wday = 0;              /* 曜日 */
t.tm_hour = hour;           /* 14時   */
t.tm_min  = min;            /* 20分   */
t.tm_sec  = sec;            /* 00秒   */
t.tm_isdst= -1;             /* 夏時間無効 */

ret = mktime(&t);

return ret;
}







// FOR RES 用、指定時間内なら実行
int floop(int year_ab, int month_ab, int day_ab, int hour_ab, int min_ab,
          int year_ob, int month_ob, int day_ob, int hour_ob, int min_ob)
{
int year_a, month_a, day_a, hour_a, min_a;
int year_o, month_o, day_o, hour_o, min_o;
int ret, rytime, rmotime, rdtime, rtime, rmtime;
time_t u_start;
time_t u_stop;
time_t u_present;
ret = -1;

rytime = ctime_getr('y');            // 現在の年をryimeに代入 
rmotime = ctime_getr('m');           // 現在の月をrmotimeに代入 
rdtime = ctime_getr('d');            // 現在の日をrdimeに代入 
rtime = ctime_getr('h');             // 現在の時間をrtimeに代入 
rmtime = ctime_getr('i');            // 現在の分をrmtimeに代入 

// 年　をフォーマット(2020年)
if(year_ab == 100){ year_a = rytime; }
else if(year_ab >= 2020){ year_a = 2020; }
else if(year_ab <= 2008){ year_a = 2008; }
else { year_a = year_ab; }

if(year_ob == 100){ year_o = rytime; }
else if(year_ob >= 2020){ year_o = 2020; }
else if(year_ob <= 2008){ year_o = 2008; }
else { year_o = year_ob; }

// 月 12以上を12に、0以下を1に整理
if(month_ab == 100){ month_a = rmotime; }
else if(month_ab >= 12){ month_a = 12; }
else if(month_ab <= 0){ month_a = 1; }
else { month_a = month_ab; }

if(month_ob == 100){ month_o = rmotime; }
else if(month_ob >= 12){ month_o = 12; }
else if(month_ob <= 0){ month_o = 1; }
else { month_o = month_ob; }

// 日 31以上を31に、0以下を1に整理
if(day_ab == 100){ day_a = rdtime; }
else if(day_ab >= 31){ day_a = 31; }
else if(day_ab <= 0){ day_a = 1; }
else { day_a = day_ab; }

if(day_ob == 100){ day_o = rdtime; }
else if(day_ob >= 31){ day_o = 31; }
else if(day_ob <= 0){ day_o = 1; }
else{ day_o = day_ob; }

// 時間 24 を0に整理
if(hour_ab == 100){ hour_a = rtime; }
else if(hour_ab >= 24){ hour_a = 0; }
else if(hour_ab <= 0){ hour_a = 0; }
else { hour_a = hour_ab; }

if(hour_ob == 100){ hour_o = rtime; }
else if(hour_ob >= 24){ hour_o = 0; }
else if(hour_ob <= 0){ hour_o = 0; }
else{ hour_o = hour_ob; }

// 分 60を60に整理
if(min_ab == 100){ min_a = rmtime; }
else if(min_ab >= 60){ min_a = 60; }
else if(min_ab <= 0){ min_a = 0; }
else{ min_a = min_ab; }

if(min_ob == 100){ min_o = rmtime; }
else if(min_ob >= 60){ min_o = 60; }
else if(min_ob <= 0){ min_o = 0; }
else{ min_o = min_ob; }

// 開始UNIX時間を得る
u_start = get_unixtime(
        year_a,
        month_a,
        day_a,
        hour_a,
        min_a,
        0);
// 停止UNIX時間を得る
u_stop = get_unixtime(
        year_o,
        month_o,
        day_o,
        hour_o,
        min_o,
        0);
// 現在のUNIX時間を得る
u_present = (time_t)u_time();


#ifdef MUTEX_BUG
printf("MUTEX: floop(): FOR RES 開始年=%d, 開始月=%d, 開始日=%d, 開始時=%d, 開始分=%d, 開始UNIX=%ld\n", 
        year_a,
        month_a,
        day_a,
        hour_a,
        min_a,
        u_start);
printf("MUTEX: floop(): FOR RES 終了年=%d, 終了月=%d, 終了日=%d, 終了時=%d, 終了分=%d, 終了UNIX=%ld\n", 
        year_o,
        month_o,
        day_o,
        hour_o,
        min_o,
        u_stop);
printf("MUTEX: floop(): FOR RES 現在年=%d, 現在月=%d, 現在日=%d, 現在時=%d, 現在分=%d 現在UNIX=%ld\n", 
        rytime,
        rmotime,
        rdtime,
        rtime,
        rmtime,
        u_present);
#endif


// 時間の比較
if(u_stop <= u_start){
   #ifdef MUTEX_BUG
   printf("MUTEX: f_loop(): FOR RES 開始停止が等しいか停止が開始より早い. \n");
   #endif
   ret = -1;
   }
else if(u_present < u_start){
   #ifdef MUTEX_BUG
   printf("MUTEX: f_loop(): FOR RES 開始時間に達してない. \n");
   #endif
   ret = -1;
   }
else if(u_present > u_stop){
   #ifdef MUTEX_BUG
   printf("MUTEX: f_loop(): FOR RES 停止時間を過ぎている. \n");
   #endif
   ret = -1;
   }
else{
   ret = 1;
   }


// 状況表示 
if(ret == 1){
   #ifdef MUTEX_BUG
   printf("MUTEX: floop(): FOR RES の条件を満たしました  ret = <%d>\n", ret);
   #endif 
   }
else{
   #ifdef MUTEX_BUG
   printf("MUTEX: floop(): FOR RES の条件を満たしていません  ret = <%d>\n", ret);
   #endif 
   }
  
return ret;
}










// 一ヶ月前の月をかえす
int m_last(int uu, int mon)
{
int ret;
ret = -1;

switch(mon){
   case 1: ret = 31; break;
   case 2: if(uu == 1){
              ret = 29;
              }
           else{
              ret = 28;
              }
                     break;
   case 3: ret = 31; break;
   case 4: ret = 30; break;
   case 5: ret = 31; break;
   case 6: ret = 30; break;
   case 7: ret = 31; break;
   case 8: ret = 31; break;
   case 9: ret = 30; break;
   case 10: ret = 31; break;
   case 11: ret = 30; break;
   case 12: ret = 31; break;
   default: ret = 0; break;
   }

return ret;
}




// 一年前をかえす
int year_minus(int year)
{
int ret;
ret = 0;

switch(year){
   case 2008: ret = 2007; break;
   case 2009: ret = 2008; break;
   case 2010: ret = 2009; break;
   case 2011: ret = 2010; break;
   case 2012: ret = 2011; break;
   case 2013: ret = 2012; break;
   case 2014: ret = 2013; break;
   case 2015: ret = 2014; break;
   case 2016: ret = 2015; break;
   case 2017: ret = 2016; break;
   case 2018: ret = 2017; break;
   case 2019: ret = 2018; break;
   case 2020: ret = 2019; break;
   default : ret = 2008; break;
   }

return ret;
}






// 現在年月の最後の日を出す
int month_last(int ye, int mon)
{
int ret;
ret = -1;

switch(ye){
   case 2008: ret = m_last(1, mon); break;
   case 2009: ret = m_last(0, mon); break;
   case 2010: ret = m_last(0, mon); break;
   case 2011: ret = m_last(0, mon); break;
   case 2012: ret = m_last(1, mon); break;
   case 2013: ret = m_last(0, mon); break;
   case 2014: ret = m_last(0, mon); break;
   case 2015: ret = m_last(0, mon); break;
   case 2016: ret = m_last(1, mon); break;
   case 2017: ret = m_last(0, mon); break;
   case 2018: ret = m_last(0, mon); break;
   case 2019: ret = m_last(0, mon); break;
   case 2020: ret = m_last(1, mon); break;
   default: ret = 0; break;
   }

return ret;
}


// 指定月から一ヶ月引いた月をかえす。単純。。。
int month_miuns(int month)
{
int ret;
ret = -1;

switch(month){
   case 1: ret = 12;  break;
   case 2: ret = 1;   break;
   case 3: ret = 2;   break;
   case 4: ret = 3;   break;
   case 5: ret = 4;   break;
   case 6: ret = 5;   break;
   case 7: ret = 6;   break;
   case 8: ret = 7;   break;
   case 9: ret = 8;   break;
   case 10: ret = 9;  break;
   case 11: ret = 10; break;
   case 12: ret = 11; break;
   default: ret = 0; break;
   }

return ret;
}





// 
int day_minus(int day_d)
{
int ret, day;
ret = -1;
day = 1;

// したごしらえ
if     (day_d <= 0){ day = 1; }
else if(day_d > 31){ day = 31; }
else               { day = day_d; }

// 本番
if(day == 1){
   switch(ctime_getr('m')){
      case 1: ret = 31; break;
      case 2: ret = 31; break;
      case 3:
      switch(ctime_getr('y')){
         case 2008: ret = 29; break;
         case 2009: ret = 28; break;
         case 2010: ret = 28; break;
         case 2011: ret = 28; break;
         case 2012: ret = 29; break;
         case 2013: ret = 28; break;
         default: ret = 28; break;
         }
                        break;
      case 4: ret = 31; break;
      case 5: ret = 30; break;
      case 6: ret = 31; break;
      case 7: ret = 30; break;
      case 8: ret = 31; break;
      case 9: ret = 31; break;
      case 10: ret = 30; break;
      case 11: ret = 31; break;
      case 12: ret = 30; break;
      default: ret = 31; break;
      }
   }
else{ ret = day - 1; }

return ret;
}







// cha 単位で t 時 から mt 時間引いた時間を返す関数 0 - 1 = 23
int time_minus(int t, int mt, char cha)
{
int an, minu;
an = 0;
minu = 0;

switch(cha){
   case 'h': minu = 24;
             break;
   case 'i': minu = 60;
             break;
   default : minu = 12;
             break;
   }

if(t >= minu){ t = 0; }
if(t <= 0){ t = 0; }
if(mt >= minu){ mt = 0; }
if(mt <= 0){ mt = 0; }

if(t == 0 && mt <= minu){
    an = minu - mt;
    }
else if(t > 0 && mt <= t){
    an = t - mt;
    }
else if(t > 0 && mt > t){
    an = minu - (mt - t);
    }

if(an == minu){
    an = 0;
    }

return an;
}




/* mail用フォーマットで現在時刻文字列をかえす */
int mail_time_getr(char buf[], int count, char * zone)
{
time_t t;
struct tm tmbuf;

t = time(NULL);
localtime_r(&t, &tmbuf);

if(20<=count){
   sprintf(buf,"%s, %02d %s %04d %02d:%02d:%02d %s",
      (char *)char_wday(tmbuf.tm_wday),
      tmbuf.tm_mday,
      (char *)char_mon(tmbuf.tm_mon),
      tmbuf.tm_year + 1900,
      tmbuf.tm_hour,
      tmbuf.tm_min,
      tmbuf.tm_sec,
      zone);
   }
return 0;
}




// 数字の順番で英語曜日の頭3文字をかえす
char * char_wday(int wday)
{
char * ret;
switch(wday){
    case 0 : ret = "Sun"; break;
    case 1 : ret = "Mon"; break;
    case 2 : ret = "Tue"; break;
    case 3 : ret = "Wed"; break;
    case 4 : ret = "Thu"; break;
    case 5 : ret = "Fri"; break;
    case 6 : ret = "Sat"; break;
    default : ret = "Not!"; break;
    }
return(ret);
}




// 数字月を英語月頭3文字でかえす
char * char_mon(int mon)
{
char * ret;
switch(mon){
    case 0 : ret = "Jan"; break;
    case 1 : ret = "Feb"; break;
    case 2 : ret = "Mar"; break;
    case 3 : ret = "Apr"; break;
    case 4 : ret = "May"; break;
    case 5 : ret = "Jun"; break;
    case 6 : ret = "Jul"; break;
    case 7 : ret = "Aug"; break;
    case 8 : ret = "Sep"; break;
    case 9 : ret = "Oct"; break;
    case 10 : ret = "Nov"; break;
    case 11 : ret = "Dec"; break;
    default : ret = "Not!"; break;
    }
return(ret);
}




/* 現在時刻を：くくりでかえす */
int time_getr(char buf[], int count)
{
time_t t;
struct tm tmbuf;

t = time(NULL);
localtime_r(&t, &tmbuf);

if(20<=count){
   sprintf(buf,"%04d:%02d:%02d:%02d:%02d:%02d",
      tmbuf.tm_year + 1900,
      tmbuf.tm_mon + 1,
      tmbuf.tm_mday,
      tmbuf.tm_hour,
      tmbuf.tm_min,
      tmbuf.tm_sec);
   }
return 0;
}




/* UNIX 時間を得る  */
long int u_time(void)
{
time_t tt;
tt = time(NULL);
return((long int)tt);
}



/* 指定キャラから今の時間日付等を返す (thread safe) */
int ctime_getr(char ch)
{
time_t t;
struct tm tmbuf;

t = time(NULL);
localtime_r(&t, &tmbuf);

switch(ch){
  case 'y': return(tmbuf.tm_year + 1900);
  case 'm': return(tmbuf.tm_mon + 1);
  case 'd': return(tmbuf.tm_mday);
  case 'h': return(tmbuf.tm_hour);
  case 'i': return(tmbuf.tm_min);
  case 's': return(tmbuf.tm_sec);
  default : break;
  }

return -1;
}





